## castle-game-engine 6.0.2+dfsg1

=== Makefile ===
# Most useful targets:
#
#   all (default target) --
#     Compile all units, uses fpmake.
#
#   examples --
#     Compile examples and tools (inside examples/ subdirectory).
#     This compilation method uses our xxx_compile.sh Unix scripts,
#     and requires only pure FPC installation.
#     Lazarus is not required (LCL dependent examples are not compiled).
#     Note that you can also compile each example separately,
#     just execute directly appropriate xxx_compile.sh scripts.
#
#   examples-laz --
#     Compile examples and tools (inside examples/ subdirectory).
#     This compilation method uses our .lpi project files,
#     and compiles every program by the lazbuild utility.
#     Lazarus and FPC installation is required, and Lazarus must know
#     about the castle_* packages (compile them from Lazarus first).
#
#   clean --
#     Delete FPC 1.0.x Windows trash (*.ppw, *.ow), FPC trash, Delphi trash,
#     Lazarus trash (*.compiled),
#     binaries of example programs,
#     also FPC compiled trash in packages/*/lib/.
#
# Not-so-commonly-useful targets:
#
#   cleanmore --
#     Same as clean, but also delete:
#     - Emacs backup files (*~) and
#     - Delphi backup files (*.~???)
#     - pasdoc generated documentation in doc/pasdoc/ and doc/reference/
#     - closed-source libs you may have left in tools/build-tool/data
#     This is a useful step when packing the release of CGE.
#
#   cleanall --
#     Same as cleanmore for now.
#     Intention is to remove *everything* that can be manually recreated,
#     even if somewhat hard, and clean editor backup.

# Hack for Cygwin, to avoid using Windows built-in "find" program.
#FIND:=/bin/find
FIND:=find

# compile ------------------------------------------------------------

.PHONY: all
all:
	$(MAKE) --no-print-directory build-using-fpmake
	tools/texture-font-to-pascal/texture-font-to-pascal_compile.sh
	tools/image-to-pascal/image-to-pascal_compile.sh
	tools/castle-curves/castle-curves_compile.sh
	tools/build-tool/castle-engine_compile.sh
	tools/sprite-sheet-to-x3d/sprite-sheet-to-x3d_compile.sh

.PHONY: build-using-fpmake
build-using-fpmake:
	fpc fpmake.pp
	@echo 'Running fpmake. If this fails saying that "rtl" is not found, remember to set FPCDIR environment variable, see http://wiki.freepascal.org/FPMake .'
# Workaround FPC >= 3.x problem (bug?) --- it ignores $FPCDIR, but --globalunitdir works
	if [ '(' -n "$(FPCDIR)" ')' -a \
	     '(' $(shell fpc -iV) '!=' '2.6.4' ')' -a \
	     '(' $(shell fpc -iV) '!=' '2.6.2' ')' ]; then \
	   ./fpmake --globalunitdir="$(FPCDIR)"; \
	else \
	   ./fpmake; \
	fi

# install / uninstall --------------------------------------------------------
#
# Note that this *does not* take care of installing the unit files.
# So it does not copy .ppu/.o files, it does not change your /etc/fpc.cfg
# or ~/.fpc.cfg. There are many ways how to install unit files,
# we leave this step up to you.
# See http://castle-engine.sourceforge.net/engine.php for documentation.
#
# Below we only take care of installing the tools.
# By default they are installed system-wide to /usr/local ,
# so you can run "make" followed by "sudo make install" to have the tools
# ready on a typical Unix system.

# Standard installation dirs, following conventions on
# http://www.gnu.org/prep/standards/html_node/Directory-Variables.html#Directory-Variables
PREFIX=$(DESTDIR)/usr/local
EXEC_PREFIX=$(PREFIX)
BINDIR=$(EXEC_PREFIX)/bin
DATAROOTDIR=$(PREFIX)/share
DATADIR=$(DATAROOTDIR)

.PHONY: install
install:
	install -d $(BINDIR)
	install tools/texture-font-to-pascal/texture-font-to-pascal $(BINDIR)
	install tools/image-to-pascal/image-to-pascal $(BINDIR)
	install tools/castle-curves/castle-curves $(BINDIR)
	install tools/build-tool/castle-engine $(BINDIR)
	install tools/sprite-sheet-to-x3d/sprite-sheet-to-x3d $(BINDIR)
#	cp -R tools/build-tool/data $(DATADIR)/castle-engine
	install -d  $(DATADIR)
	cd tools/build-tool/data/ && \
	  $(FIND) . -type f -exec install --mode 644 -D '{}' $(DATADIR)/castle-engine/'{}' ';'

.PHONY: uninstall
uninstall:
	rm -f  $(BINDIR)/texture-font-to-pascal \
	       $(BINDIR)/image-to-pascal \
	       $(BINDIR)/castle-curves \
	       $(BINDIR)/castle-engine \
	       $(BINDIR)/sprite-sheet-to-x3d
	rm -Rf $(DATADIR)/castle-engine

# Strip libraries that cannot be distributed in Debian package of CGE for now,
# because they (possibly) cannot be recompiled by Debian software right now
# (or maybe they can, but noone had time to try it yet, and wrap in a script).
# This concerns some Windows and Android libs.
.PHONY: strip-precompiled-libraries
strip-precompiled-libraries:
	rm -Rf tools/build-tool/data/external_libraries/ \
	       tools/build-tool/data/android/integrated-components/sound/ \
	       tools/build-tool/data/android/integrated-components/ogg_vorbis/

# examples and tools -----------------------------------------------------------

# Note that images/examples/fft_tests is not included here,
# and unit images/imagesfftw.pas is not included in fpmake.pp,
# because
# 1. it requires to compile FPC > 2.2.x, and we try to work also with earlier FPC.
# 2. to link the example, you need the fftw library. I don't want
#    to force everyone who wants to execute "make examples" to install
#    fftw library (especially since it's really not needed by my engine,
#    currently my fftw code is just for testing, it's not actually used
#    by our engine or any game for anything).

EXAMPLES_BASE_NAMES := \
  examples/audio/algets \
  examples/audio/alplay \
  examples/audio/doppler_demo \
  examples/audio/efx_demo \
  examples/tools/dircleaner \
  examples/tools/stringoper \
  examples/tools/castle_download \
  examples/tools/to_data_uri \
  examples/castlescript/castle_calculator \
  examples/castlescript/image_make_by_script \
  examples/images_videos/image_convert \
  examples/images_videos/dds_decompose \
  examples/images_videos/image_identify \
  examples/images_videos/image_compare \
  examples/images_videos/simple_video_editor \
  examples/images_videos/drawing_modes_test \
  examples/joystick/joystick_demo \
  examples/fonts/test_font_break \
  examples/fonts/font_from_texture \
  examples/fonts/test_local_characters/test_local_characters \
  examples/fonts/html_text \
  examples/tiled/tiled_demo_standalone \
  examples/window/window_events \
  examples/window/window_menu \
  examples/window/window_gtk_mix \
  examples/window/multi_window \
  examples/curves_surfaces/bezier_surfaces/animate_surface \
  examples/curves_surfaces/bezier_surfaces/design_surface \
  examples/curves_surfaces/interpolated_curves \
  examples/curves_surfaces/simplest_curve_read \
  examples/space_filling_curve/draw_space_filling_curve \
  examples/research_special_rendering_methods/radiance_transfer/radiance_transfer \
  examples/research_special_rendering_methods/radiance_transfer/precompute_radiance_transfer \
  examples/research_special_rendering_methods/radiance_transfer/show_sh \
  examples/research_special_rendering_methods/shadow_fields/precompute_shadow_field \
  examples/research_special_rendering_methods/shadow_fields/shadow_fields \
  examples/research_special_rendering_methods/dynamic_ambient_occlusion/dynamic_ambient_occlusion \
  examples/terrain/terrain \
  examples/3d_rendering_processing/custom_3d_object \
  examples/3d_rendering_processing/triangulate_demo \
  examples/3d_rendering_processing/placeholder_names \
  examples/3d_rendering_processing/tools/gen_light_map \
  examples/3d_rendering_processing/tools/castle_anim_frames_to_interpolators \
  examples/3d_rendering_processing/multiple_viewports \
  examples/3d_rendering_processing/fog_culling \
  examples/research_special_rendering_methods/plane_mirror_and_shadow/plane_mirror_and_shadow \
  examples/3d_rendering_processing/animate_3d_model_by_code \
  examples/3d_rendering_processing/animate_3d_model_by_code_2 \
  examples/3d_rendering_processing/call_pascal_code_from_3d_model_script \
  examples/3d_rendering_processing/view_3d_model_advanced \
  examples/3d_rendering_processing/scene_manager_demos \
  examples/3d_rendering_processing/view_3d_model_basic \
  examples/3d_rendering_processing/build_3d_object_by_code \
  examples/3d_rendering_processing/build_3d_tunnel \
  examples/3d_rendering_processing/combine_multiple_x3d_into_one \
  examples/3d_rendering_processing/listen_on_x3d_events \
  examples/3d_rendering_processing/cars_demo \
  examples/3d_rendering_processing/render_3d_to_texture_and_use_as_quad \
  src/x3d/teapot/teapot_3d_to_pascal \
  src/x3d/nodes_specification/x3d_nodes_spec_to_pascal/x3d_nodes_spec_to_pascal \
  src/x3d/nodes_specification/generate_x3d_nodes_helpers/generate_x3d_nodes_to_pascal \
  examples/fixed_camera_game/rift \
  examples/isometric_game/sandbox \
  examples/3d_sound_game/lets_take_a_walk \
  examples/3d_sound_game/data/levels/base/devel/process_base_b \
  examples/resource_animations/resource_animations \
  examples/fps_game/fps_game \
  examples/2d_standard_ui/show_various_ui_controls/show_various_ui_controls \
  examples/2d_standard_ui/timer_test/timer_test \
  examples/2d_standard_ui/zombie_fighter/zombie_fighter \
  examples/android/android_demo/androiddemo_standalone \
  tools/build-tool/castle-engine \
  tools/image-to-pascal/image-to-pascal \
  tools/texture-font-to-pascal/texture-font-to-pascal \
  tools/castle-curves/castle-curves \
  tools/sprite-sheet-to-x3d/sprite-sheet-to-x3d \
  examples/random_generator/random_speed_test \
  examples/random_generator/random_threads_test

EXAMPLES_LAZARUS_BASE_NAMES := \
  examples/audio/test_al_source_allocator \
  examples/lazarus/model_3d_viewer/model_3d_viewer \
  examples/lazarus/model_3d_with_2d_controls/model_3d_with_2d_controls \
  examples/lazarus/load_model_and_camera_manually/load_model_and_camera_manually \
  examples/lazarus/two_controls/two_controls \
  tests/test_castle_game_engine \
  src/library/castleengine \
  examples/library/lcl_dynlib_tester/cge_dynlib_tester \
  examples/random_generator/graphics_random_test

EXAMPLES_UNIX_EXECUTABLES := $(EXAMPLES_BASE_NAMES) \
  $(EXAMPLES_LAZARUS_BASE_NAMES)

EXAMPLES_WINDOWS_EXECUTABLES := $(addsuffix .exe,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .exe,$(EXAMPLES_LAZARUS_BASE_NAMES))

EXAMPLES_MACOSX_APPS := $(addsuffix .app,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .app,$(EXAMPLES_LAZARUS_BASE_NAMES))

EXAMPLES_RES_FILES := $(addsuffix .res,$(EXAMPLES_BASE_NAMES)) \
  $(addsuffix .res,$(EXAMPLES_LAZARUS_BASE_NAMES))

.PHONY: examples
examples:
	$(foreach NAME,$(EXAMPLES_BASE_NAMES),$(NAME)_compile.sh && ) true
# compile all examples with CastleEngineManifest.xml inside
	$(FIND) . -iname CastleEngineManifest.xml -execdir castle-engine $(CASTLE_ENGINE_TOOL_OPTIONS) compile ';'

.PHONY: examples-ignore-errors
examples-ignore-errors:
	$(foreach NAME,$(EXAMPLES_BASE_NAMES),$(NAME)_compile.sh ; ) true

.PHONY: cleanexamples
cleanexamples:
	rm -f $(EXAMPLES_UNIX_EXECUTABLES) $(EXAMPLES_WINDOWS_EXECUTABLES) $(EXAMPLES_RES_FILES)
	rm -Rf $(EXAMPLES_MACOSX_APPS)

.PHONY: examples-laz
examples-laz:
	lazbuild packages/castle_base.lpk
	lazbuild packages/castle_window.lpk
	lazbuild packages/castle_components.lpk
	$(foreach NAME,$(EXAMPLES_BASE_NAMES) $(EXAMPLES_LAZARUS_BASE_NAMES),lazbuild $(NAME).lpi && ) true

# cleaning ------------------------------------------------------------

.PHONY: clean cleanmore cleanall

clean: cleanexamples
	$(FIND) . -type f '(' -iname '*.ow'  -or -iname '*.ppw' -or -iname '*.aw' -or \
	                   -iname '*.o'   -or -iname '*.ppu' -or -iname '*.a' -or \
			   -iname '*.or'  -or \
			   -iname '*.rsj' -or \
			   -iname '*.compiled' -or \
			   -iname '*.lps' -or \
			   -iname '*.libimp*.a' -or \
			   -iname '*.apk' -or \
	                   -iname '*.dcu' -or -iname '*.dpu' -or \
	                   -iname '*.log' -or \
			   -iname 'castleengine.dll' -or -iname 'libcastleengine.so' ')' \
	     -print \
	     | xargs rm -f

=== doc/pasdoc/Makefile ===
# Main targets to gen final docs ----------------------------------------

.PHONY: default html pdf ps rtf latex

# html and pdf are two most useful versions of documentation,
# shown on [http://castle-engine.sourceforge.net/reference.php]
# Later: pdf now removed, useless and ugly.
default: html

# Run "make" in logo/ first,
# if you have inkscape installed,
# and you want to regenerate logo from png.
#
# Run "make" in html-parts/ first,
# if you have cge-www repository (https://github.com/castle-engine/cge-www)
# cloned and placed as a sibling to castle-engine, in ../../../cge-www/

html:
	./mk_docs.sh html
	mv html ../reference/
	cp logo/castle_game_engine_icon.png ../reference/

# Just some shortcuts to "Helpful targets" below
pdf: latex/docs.pdf
ps: latex/docs.ps
rtf: latex2rtf/docs.rtf
latex: latex/docs.tex

# Helpful targets to gen docs ----------------------------------------

latex2rtf/docs.tex:
	./mk_docs.sh latex2rtf

latex2rtf/docs.rtf: latex2rtf/docs.tex
	cd latex2rtf; latex2rtf docs.tex

latex/docs.tex:
	./mk_docs.sh latex

TEX_BATCH_OPTS := --file-line-error-style -interaction=nonstopmode

latex/docs.dvi: latex/docs.tex
	-cd latex; latex $(TEX_BATCH_OPTS) docs.tex
	-cd latex; latex $(TEX_BATCH_OPTS) docs.tex

# At the end of pdf generating, we clean useless junk
# (because it's quite large, and I may want to upload latex/
# dir to WWW page of my units)
latex/docs.pdf: latex/docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	-cd latex; pdflatex $(TEX_BATCH_OPTS) docs.tex
	rm -f latex/docs.aux \
	      latex/docs.log \
	      latex/docs.out \
	      latex/docs.toc

latex/docs.ps: latex/docs.dvi
	cd latex; dvips docs.dvi -o docs.ps

# Cleaning ------------------------------------------------------------

.PHONY: clean-cache clean

clean-cache:
	rm -fR cache/

clean: clean-cache
	rm -Rf html/ latex/ latex2rtf/ ../reference/

# upload ---------------------------------------------------------------------

SF_USERNAME=kambi
SF_HOST=web.sourceforge.net
SF_PATH=/home/project-web/castle-engine/htdocs/apidoc/

SF_CONNECT=$(SF_USERNAME),castle-engine@$(SF_HOST):$(SF_PATH)
SCP_OPTIONS=

# Prepare and upload all the stuff referenced under
# [http://castle-engine.sourceforge.net/reference.php].
# Uploads as tar.gz and unpacks on server, this is *much* faster than
# uploading separate HTML files.
.PHONY: upload
upload: clean html
	mv ../reference/ html
	tar czvf html.tar.gz html
	scp $(SCP_OPTIONS) -r html.tar.gz $(SF_CONNECT)
	./sf_upload_finalize.sh $(SF_USERNAME) $(SF_PATH)

=== examples/2d_dragon_spine_android_game/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

.PHONY: standalone
standalone:
	castle-engine compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: release-win32
release-win32:
	castle-engine package --os=win32 --cpu=i386

.PHONY: release-linux
release-linux:
	castle-engine package --os=linux --cpu=i386

.PHONY: release-src
release-src:
	castle-engine package-source

.PHONY: release-android
release-android:
	castle-engine package --os=android --cpu=arm
	castle-engine install --os=android --cpu=arm
	castle-engine run --os=android --cpu=arm

=== src/components/icons/Makefile ===
.PHONY: all
all: *.png castleicons.lrs

tcastle2dcontrol.png: tcastle2dcontrol.xcf
	xcf2png $< $@

castleicons.lrs: *.png
	lazres castleicons.lrs *.png

.PHONY: clean
clean:
	rm -f castleicons.lrs

=== tools/build-tool/embedded_images/Makefile ===
.PHONY: all clean

ALL_UNITS=../toolembeddedimages.pas

all: $(ALL_UNITS)

clean:
	rm -f $(ALL_UNITS)

../toolembeddedimages.pas: DefaultIcon.png
	image-to-pascal --output .. ToolEmbeddedImages DefaultIcon.png

=== tools/build-tool/templates/Makefile ===
# This requires file_to_pascal_string that is a trivial program
# that I made for pasdoc [http://pasdoc.sf.net/] project, see
# [https://pasdoc.svn.sourceforge.net/svnroot/pasdoc/trunk/source/tools/file_to_pascal_string.dpr]

ALL_TARGETS := \
  windows/plugin-automatic-windows-resources.rc.inc \
  windows/automatic-windows-resources.rc.inc \
  windows/automatic-windows.manifest.inc

default: $(ALL_TARGETS)

clean:
	rm -f $(ALL_TARGETS)

%.inc: %
	file_to_pascal_string $< $@

=== src/ui/opengl/gui-images/Makefile ===
.PHONY: all clean

ALL_UNITS=../castlecontrolsimages.pas

all: $(ALL_UNITS)

clean:
	rm -f $(ALL_UNITS)

../castlecontrolsimages.pas: Panel.png PanelSeparator.png \
  Tooltip.png TooltipRounded.png \
  ButtonPressed.png ButtonDisabled.png ButtonFocused.png ButtonNormal.png \
  WindowDark.png WindowGray.png WindowDarkTransparent.png \
  ScrollbarFrame.png ScrollbarSlider.png Slider.png SliderPosition.png \
  FrameWhite.png FrameWhiteBlack.png FrameYellow.png FrameYellowBlack.png \
  FrameThickWhite.png FrameThickYellow.png \
  ProgressBar.png ProgressFill.png \
  TouchCtlInner.png TouchCtlOuter.png TouchCtlFlyInner.png TouchCtlFlyOuter.png \
  Crosshair1.png Crosshair2.png ErrorBackground.png Loading.png
	image-to-pascal --output .. CastleControlsImages \
	  Panel.png WindowDarkTransparent.png Slider.png \
	  Tooltip.png TooltipRounded.png \
	  ButtonPressed.png ButtonDisabled.png ButtonFocused.png ButtonNormal.png \
	  FrameWhite.png FrameWhiteBlack.png FrameYellow.png FrameYellowBlack.png \
	  FrameThickWhite.png FrameThickYellow.png ProgressBar.png ProgressFill.png \
	  TouchCtlInner.png TouchCtlOuter.png TouchCtlFlyInner.png TouchCtlFlyOuter.png \
	  Loading.png Crosshair1.png Crosshair2.png ScrollbarSlider.png \
	  @alpha=strip \
	  PanelSeparator.png WindowDark.png WindowGray.png \
	  ScrollbarFrame.png \
	  SliderPosition.png ErrorBackground.png

=== src/x3d/opengl/glsl/Makefile ===
# Note about file_to_pascal_string: it's another program of mine,
# you can get it from pasdoc [http://pasdoc.sourceforge.net/] sources.

ALL_OUTPUT := shadow_map_common.fs.inc \
  variance_shadow_map_common.fs.inc \
  variance_shadow_map_generate.fs.inc \
  template.vs.inc template.fs.inc template.gs.inc \
  template_add_light.glsl.inc \
  ssao.glsl.inc screen_effect_library.glsl.inc screen_effect.vs.inc \
  template_mobile.vs.inc template_mobile.fs.inc template_mobile_add_light.glsl.inc \
  fallback.vs.inc fallback.fs.inc

.PHONY: all
all: $(ALL_OUTPUT)

%.inc: %
	file_to_pascal_string $< $@

.PHONY: clean
clean:
	rm -f $(ALL_OUTPUT)

=== debian/changelog ===
castle-game-engine (6.0.2+dfsg1-2) experimental; urgency=medium

  * Improve the FTBFS on arm64 by adding it to the list of archs
  * Fix FTBFS on armel, armhf and powerpc in test-suite with upstream
    patch to change epsilon
  * Install examples into castle-game-engine-doc
  * Add upstream patch to enable generating all man-pages during build
    (instead of requiring an x-server session to do so)

 -- Paul Gevers <elbrus@debian.org>  Fri, 31 Mar 2017 20:19:13 +0200

castle-game-engine (6.0.2+dfsg1-1) experimental; urgency=medium

  * New upstream release
    - Adapt to new layout of the source
    - Refresh patches and remove obsolete ones
  * Update d/copyright for new upstream version
    - Strip convenience copies without source with the aid of d/watch
  * Update d/watch for new upstream location and Files-Excluded support
  * Bump compat level to 10
  * Update upstream homepage
  * Replace obsolete -s option in dh-* calls with -a in d/rules
  * Improve the copying of the src code
  * Ship the tools that are part of cge in fp-units-castle-game-engine
  * generate auto-generated files in d/rules
  * Improve Debian situation for builders of Android applications
  * Depend on libjs-jquery for documentation (added by pasdoc)

 -- Paul Gevers <elbrus@debian.org>  Fri, 24 Mar 2017 15:43:33 +0100

=== debian/control ===
Source: castle-game-engine
Section: misc
Priority: optional
Maintainer: Pascal Packaging Team <pkg-pascal-devel@lists.alioth.debian.org>
Uploaders:
 Abou Al Montacir <abou.almontacir@sfr.fr>,
 Paul Gevers <elbrus@debian.org>
Standards-Version: 3.9.8
Build-Depends:
 debhelper (>= 10~),
 dh-exec,
 fonts-dejavu,
 fp-compiler,
 fp-units-base,
 fp-units-db,
 fp-units-fcl,
 fp-units-gfx,
 fp-units-gtk2,
 fp-units-misc,
 fp-units-multimedia,
 fp-units-net,
 fp-utils (>= 2.6.2),
 help2man,
 libatk1.0-dev,
 libcairo2-dev,
 libfreetype6-dev,
 libgdk-pixbuf2.0-dev,
 libgtk2.0-dev,
 libgtkglext1-dev,
 libpango1.0-dev,
 xcftools,
Build-Depends-Indep:
 inkscape,
 pasdoc (>= 0.14.0),
Vcs-Git: https://anonscm.debian.org/git/pkg-pascal/castle-game-engine.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-pascal/castle-game-engine.git
Homepage: https://castle-engine.sourceforge.io/engine.php

Package: fp-units-castle-game-engine
Architecture: any
Built-Using: fonts-dejavu (= ${dejavu:version})
Depends:
 ${fpc-abi:Depends},
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 castle-game-engine-src,
 gradle,
Description: Castle Game Engine - 3D game engine for FreePascal / Lazarus
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains the FPC units and the auxiliary tools castle-curves,
 castle-engine, image-to-pascal, sprite-sheet-to-x3d, and
 texture-font-to-pascal.
 .
 This package suggests the gradle package. Gradle is only necessary if one
 wants to build Android applications, otherwise one can ignore that
 suggestion. Note that, in order to create Android applications, one will also
 need the Android SDK and NDK, and FPC cross-compiler, see
 https://github.com/castle-engine/castle-engine/wiki/Android.

Package: castle-game-engine-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends}
Suggests:
 castle-game-engine-src,
 fp-units-castle-game-engine,
 libjs-jquery,
Description: Castle Game Engine - Developer's Documentation
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains documentation.

Package: castle-game-engine-src
Section: doc
Architecture: all
Built-Using: fonts-dejavu (= ${dejavu:version})
Depends:
 fonts-dejavu,
 ${misc:Depends}
Recommends:
 castle-game-engine-doc,
 fpc,
 lazarus
Suggests:
 fp-units-castle-game-engine
Description: Castle Game Engine - Source code for Lazarus integration
 Castle Game Engine is a set of LGPL licenced libraries that are intended to
 ease developing 3D games with FreePascal / Lazarus.
 .
 It provides an excellent support for the VRML / X3D 3D data format. Other 3D
 formats are also supported.
 .
 It features many advanced graphic effects and easy to use API on top of OpenGL.
 .
 This package contains source code for integration with Lazarus RAD IDE.

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for Castle Game Engine

DEB_PACKAGE_NAME=castle-game-engine
export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
export LANG:=C

# Documentation type to use chm/html
ifeq (${DEBDOCTYPE},)
DOCTYPE=html
# HTML Converter chmdocs or htmldocs for (default)
CONVERTER=${DOCTYPE}docs
else
DOCTYPE=${DEBDOCTYPE}
CONVERTER=${DOCTYPE}docs
endif
# Define FPC
ifndef FPC
FPC=/usr/bin/fpc
endif
# Set FPCVER
FPCVER=$(shell ${FPC} -iV)

CPU_TARGET?=$(shell ${FPC} -iTP)
OS_TARGET?=$(shell ${FPC} -iTO)
FPCTARGET=${CPU_TARGET}-${OS_TARGET}
# Get version information from changelog file
DEB_VERSION:=$(shell dpkg-parsechangelog | grep '^Version:' | cut -f 2 -d ' ')
DEB_UPSTREAM_VERSION:=$(shell echo $(DEB_VERSION) | cut -f 1 -d -)
# Used in dh-exec enhanced files
export CGE_VERSION=${DEB_UPSTREAM_VERSION}
DEB_UPSTREAM_MAIN_VERSION:=$(shell echo ${DEB_UPSTREAM_VERSION} | sed -e 's/^\([0-9\.]*\).*/\1/')
DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
ifndef PACKAGESUFFIX
PACKAGESUFFIX=-${DEB_UPSTREAM_MAIN_VERSION}
endif
DEB_HOST_MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
# Get directories
CURDIR:=$(shell pwd)
INSTALL_DIR=$(CURDIR)/debian/tmp
LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_PACKAGE_NAME}/${DEB_UPSTREAM_MAIN_VERSION}
SRC_DIR=${INSTALL_DIR}/usr/src/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
UNITS_DIR=${INSTALL_DIR}/usr/lib/${DEB_HOST_MULTIARCH}/fp-units-${FPCVER}/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
TMP_DIR=${INSTALL_DIR}/tmp
# Get utils
ifndef MKDIR
MKDIR=mkdir -p
endif
ifndef CP
CP=cp -Rfpl
endif
RM:=rm -rf
# Get fpcmake from path if none is specified.
ifndef FPCMAKE
FPCMAKE=fpcmake
endif
# Define FPCDIR if it was not set
ifndef FPCDIR
export FPCDIR=/usr/lib/fpc/${FPCVER}
endif
ifndef LAZBUILD
LAZBUILD=lazbuild
endif
# Set default compilation options
BUILDOPTS=

# Until we switch to shorthand dh, we need to set this ourselves for
# reproducible builds
export SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)

#export DH_VERBOSE=1

###################
# Clean
#

clean: configure clean-patched
	${MAKE} cleanall
	# dh_clean gets a list of files from the debian/clean file
	dh_clean
clean-patched:
	@echo "--- Cleaning"
	dh_testdir
	$(MAKE) cleanall
	$(MAKE) strip-precompiled-libraries
	dh_prep

###################
# Arch packages
#

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Remove auto-generated make files.
	find -name Makefile.fpc -execdir 'sh' '-c' '${RM} $$(basename {} .fpc)' ';'
#	# Regenrate make files using fpcmake.
#	${FPCMAKE} -r -Tall
#	# Remove auto-generated version file.
#	${RM} ide/version.inc
#	# Add version.inc:
#	echo \'$(DEB_VERSION)\' > version.inc
	touch configure-stamp

prepare-source: prepare-source-stamp
prepare-source-stamp:
	# Building Pascal style font file first while making sure that
	# no unit or object files polute the source tree
	${MKDIR} ${TMP_DIR}
	${FPC} -FE${TMP_DIR}  @castle-fpc.cfg tools/texture-font-to-pascal/texture-font-to-pascal.lpr
	cd src/fonts ; PATH=${PATH}:${TMP_DIR} ./mk_fonts.sh

	# cge embeds some images from xcf via png into Pascal source files
	# First we need to create the pngs
	for pngfile in $$(grep \\\.png\$$ debian/clean) ; do xcf2png $${pngfile%.png}.xcf -o $${pngfile} ; done
	# Then we build the helper function
	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg tools/image-to-pascal/image-to-pascal.lpr
	# To finally convert png files to pas file
	PATH=${TMP_DIR} ${MAKE} -C src/ui/opengl/gui-images all

	# Upstream source contains auto-generated include files. Let's generate
	# them again.
	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg src/x3d/nodes_specification/generate_x3d_nodes_helpers/generate_x3d_nodes_to_pascal.lpr
	cd src/x3d/nodes_specification/generate_x3d_nodes_helpers ; \
		PATH=${TMP_DIR} generate_x3d_nodes_to_pascal ../components/*.txt

	# For reproducible builds we need to make sure the timestamp of the just
	# created files is fixed. Let's use SOURCE_DATE_EPOCH for that. For the
	# future, this needs to be even smarter, because now every Debian revision
	# will require all the reverse dependencies generating ppu files to be
	# rebuild.
	touch --no-dereference --date="@$${SOURCE_DATE_EPOCH}" \
		src/x3d/auto_generated_node_helpers/*.inc \
		src/fonts/castletexturefont_*.pas \
		src/ui/opengl/castlecontrolsimages.*

	touch prepare-source-stamp

build-arch: configure prepare-source install-source build-arch-stamp
build-arch-stamp:
	@echo "--- Building"
	dh_testdir
	# Build the real engine
	${MAKE} all
	# Generate man pages
	${MAKE} -C doc/man/man1

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Code to run the package test suite.
	# Command basically copied from tests/compile_console.sh while
	# making sure that no unit or object files polute the source tree
	${FPC}  -gh -dDEBUG -dTEXT_RUNNER -dNO_WINDOW_SYSTEM \
		-Fuexamples/research_special_rendering_methods/shadow_fields/ \
		-Fuexamples/curves_surfaces/ \
		-FE${TMP_DIR} \
		@castle-fpc.cfg tests/test_castle_game_engine.lpr
	# cd is needed to find the data files
	cd tests ; ${TMP_DIR}/test_castle_game_engine -a
endif

	touch build-arch-stamp

install-arch: build-arch install-arch-stamp
install-arch-stamp:
	@echo "--- Installing"
	dh_testdir
	dh_testroot
	dh_installdirs
	# Install units
	${MKDIR} ${UNITS_DIR}
	${CP} -t ${UNITS_DIR} units/${FPCTARGET}/*
	# copy images, sounds, icons and menu entries for the GNOME menu
	#${MKDIR} $(INSTALL_DIR)/usr/share
	#${CP} -t $(INSTALL_DIR)/usr/share \
	#  build/share/applications \
	#  build/share/icons \
	#  build/share/images \
	#  build/share/locale \
	#  build/share/man \
	#  build/share/sounds
	# Mark package as manually compilable and install them
	for package in $$(find * -name '*.lpk') ; \
	do \
		pkgDir=$$(dirname "${LIB_DIR}/$${package}") ; \
		${MKDIR} "$${pkgDir}" ; \
		sed -e 's@\(\W*\)<CompilerOptions>.*@\1<AutoUpdate Value="Manually"/>\n&@' \
		    -e "s@\.\./src/@$$(relpath ${SRC_DIR} $${pkgDir})/@g" \
		    -e "s@\(\W*\)<UnitOutputDirectory .*@<UnitOutputDirectory Value=\"$$(relpath ${UNITS_DIR} $${pkgDir})\"/>@" \
		    "$${package}" > "${LIB_DIR}/$${package}" ; \
	done
	# Call upstream install target for the tools
	${MAKE} PREFIX=${INSTALL_DIR}/usr install
	find ${INSTALL_DIR} -empty -delete
	touch install-arch-stamp

build-indep: configure prepare-source install-source build-doc
install-indep: install-doc install-source

###################
# Documentation
#

build-doc: build-doc-stamp
build-doc-stamp:
	@echo "--- Building Documentation"
	dh_testdir
	# Create logo first, before generating documentation
	${MAKE} -C doc/pasdoc/logo
	${MAKE} -C doc/pasdoc ${DOCTYPE}
	# pasdoc create a jquery file, but we link from jquery instead
	${RM} doc/reference/tipuesearch/jquery.min.js
	touch build-doc-stamp

install-doc: build-doc install-doc-stamp
install-doc-stamp:
	@echo "--- Installing Documentation"
	dh_testdir
	dh_testroot
	# No need to do anything now as we take specific docs straight
	# from the source dir with dh_installdocs in the binary-indep target
	touch install-doc-stamp

###################
# Source
#

# Annoying thing is we need to do this very early to save lots of overhead. If
# it can be done on a clean tree, right after prepare-source we don't need
# cleaning, right.
install-source: install-source-stamp
install-source-stamp:
	@echo "--- Copying the source code"
	dh_testdir
	${MKDIR} ${SRC_DIR}
	${CP} -t ${SRC_DIR} \
		$(CURDIR)/src/*
	find $(INSTALL_DIR) -name '*.bmp' -exec chmod 644 '{}' ';'
	find ${SRC_DIR} -empty -delete
	touch install-source-stamp

###################
# Generic
#

build: build-arch build-indep
install: install-arch install-indep
binary: binary-arch binary-indep


###################
# Deb building
#

binary-indep: install-indep
	@echo "--- Building: arch-indep packages"
	dh_testdir
	dh_testroot
	dh_installdocs -i -X.in
	dh_installchangelogs -i
	dh_installexamples -i
	dh_install -i -Xtmp/tmp/ --list-missing
	dh_link -i
	dh_lintian

ifeq (${DEB_BUILD},0)

=== debian/watch ===
version=4
opts=\
compression=xz,\
repack,\
repacksuffix=+dfsg1,\
dversionmangle=s/\+dfsg(\d*)//,\
"filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%castle-game-$1.tar.xz%" \
    https://github.com/castle-engine/castle-engine/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian

## castle-game-engine 6.2+dfsg1

=== Makefile ===
--- 
+++ 
@@ -32,6 +32,7 @@
 #     - Delphi backup files (*.~???)
 #     - pasdoc generated documentation in doc/pasdoc/ and doc/reference/
 #     - closed-source libs you may have left in tools/build-tool/data
+#     - QtCreator *.pro.user
 #     This is a useful step when packing the release of CGE.
 #
 #   cleanall --
@@ -110,15 +111,23 @@
 	       $(BINDIR)/sprite-sheet-to-x3d
 	rm -Rf $(DATADIR)/castle-engine
 
-# Strip libraries that cannot be distributed in Debian package of CGE for now,
-# because they (possibly) cannot be recompiled by Debian software right now
-# (or maybe they can, but noone had time to try it yet, and wrap in a script).
-# This concerns some Windows and Android libs.
+# Strip libraries that cannot be distributed in Debian package of CGE.
+# - Some of them (some bundled Windows, Android libs) cannot be recompiled
+#   automatically and easily for now (although they are open-source),
+#   and are not of sufficient interest to the Debian users.
+# - Some (Gradle) should be better used by depending on
+#   the appropriate Debian package.
 .PHONY: strip-precompiled-libraries
 strip-precompiled-libraries:
 	rm -Rf tools/build-tool/data/external_libraries/ \
-	       tools/build-tool/data/android/integrated-components/sound/ \
-	       tools/build-tool/data/android/integrated-components/ogg_vorbis/
+	       tools/build-tool/data/android/integrated-services/sound/ \
+	       tools/build-tool/data/android/integrated-services/ogg_vorbis/ \
+	       tools/build-tool/data/android/base/gradle/ \
+	       tools/build-tool/data/android/base/gradlew \
+	       tools/build-tool/data/android/base/gradlew.bat \
+	       tools/build-tool/data/android/integrated/gradle/ \
+	       tools/build-tool/data/android/integrated/gradlew \
+	       tools/build-tool/data/android/integrated/gradlew.bat
 
 # examples and tools -----------------------------------------------------------
 
@@ -154,6 +163,7 @@
   examples/fonts/font_from_texture \
   examples/fonts/test_local_characters/test_local_characters \
   examples/fonts/html_text \
+  examples/fonts/font_draw_over_image \
   examples/tiled/tiled_demo_standalone \
   examples/window/window_events \
   examples/window/window_menu \
@@ -192,8 +202,7 @@
   examples/3d_rendering_processing/cars_demo \
   examples/3d_rendering_processing/render_3d_to_texture_and_use_as_quad \
   src/x3d/teapot/teapot_3d_to_pascal \
-  src/x3d/nodes_specification/x3d_nodes_spec_to_pascal/x3d_nodes_spec_to_pascal \
-  src/x3d/nodes_specification/generate_x3d_nodes_helpers/generate_x3d_nodes_to_pascal \
+  src/x3d/nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal \
   examples/fixed_camera_game/rift \
   examples/isometric_game/sandbox \
   examples/3d_sound_game/lets_take_a_walk \
@@ -201,9 +210,10 @@
   examples/resource_animations/resource_animations \
   examples/fps_game/fps_game \
   examples/2d_standard_ui/show_various_ui_controls/show_various_ui_controls \
+  examples/2d_standard_ui/edit_test/edit_test \
   examples/2d_standard_ui/timer_test/timer_test \
   examples/2d_standard_ui/zombie_fighter/zombie_fighter \
-  examples/android/android_demo/androiddemo_standalone \
+  examples/mobile/simple_3d_demo/simple_3d_demo_standalone \
   tools/build-tool/castle-engine \
   tools/image-to-pascal/image-to-pascal \
   tools/texture-font-to-pascal/texture-font-to-pascal \
@@ -214,13 +224,14 @@
 
 EXAMPLES_LAZARUS_BASE_NAMES := \
   examples/audio/test_al_source_allocator \
+  examples/audio/audio_player_scrubber/audio_player_scrubber \
   examples/lazarus/model_3d_viewer/model_3d_viewer \
   examples/lazarus/model_3d_with_2d_controls/model_3d_with_2d_controls \
   examples/lazarus/load_model_and_camera_manually/load_model_and_camera_manually \
   examples/lazarus/two_controls/two_controls \
   tests/test_castle_game_engine \
   src/library/castleengine \
-  examples/library/lcl_dynlib_tester/cge_dynlib_tester \
+  examples/library/lazarus_library_tester/cge_dynlib_tester \
   examples/random_generator/graphics_random_test
 
 EXAMPLES_UNIX_EXECUTABLES := $(EXAMPLES_BASE_NAMES) \
@@ -262,16 +273,3 @@
 .PHONY: clean cleanmore cleanall
 
 clean: cleanexamples
-	$(FIND) . -type f '(' -iname '*.ow'  -or -iname '*.ppw' -or -iname '*.aw' -or \
-	                   -iname '*.o'   -or -iname '*.ppu' -or -iname '*.a' -or \
-			   -iname '*.or'  -or \
-			   -iname '*.rsj' -or \
-			   -iname '*.compiled' -or \
-			   -iname '*.lps' -or \
-			   -iname '*.libimp*.a' -or \
-			   -iname '*.apk' -or \
-	                   -iname '*.dcu' -or -iname '*.dpu' -or \
-	                   -iname '*.log' -or \
-			   -iname 'castleengine.dll' -or -iname 'libcastleengine.so' ')' \
-	     -print \
-	     | xargs rm -f

=== examples/2d_dragon_spine_game/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: compile
compile:
	castle-engine --mode=$(MODE)  compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32:
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: linux
linux:
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --os=android --cpu=arm
	castle-engine install --os=android --cpu=arm
	castle-engine run --os=android --cpu=arm

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS

=== examples/mobile/simple_3d_demo/Makefile ===
# This Makefile uses castle-engine build tool for most operations.
# See https://github.com/castle-engine/castle-engine/wiki/Build-Tool .

MODE:=debug

.PHONY: compile
compile:
	castle-engine --mode=$(MODE) compile $(CASTLE_ENGINE_TOOL_OPTIONS)

.PHONY: clean
clean:
	castle-engine clean

.PHONY: win32
win32:
	castle-engine --mode=$(MODE) package --os=win32 --cpu=i386

.PHONY: linux
linux:
	castle-engine --mode=$(MODE) package --os=linux --cpu=i386

.PHONY: src
src:
	castle-engine --mode=$(MODE) package-source

.PHONY: android
android:
	castle-engine --mode=$(MODE) package --os=android --cpu=arm
	castle-engine install --os=android --cpu=arm
	castle-engine run --os=android --cpu=arm

.PHONY: ios
ios:
	castle-engine --mode=$(MODE) package --target=iOS

.PHONY: ios-quick
ios-quick:
	castle-engine --mode=$(MODE) compile --target=iOS
	castle-engine --mode=$(MODE) package --target=iOS --assume-compiled

=== tools/build-tool/embedded_images/Makefile ===
.PHONY: all clean

ALL_UNITS=../toolembeddedimages.pas

all: $(ALL_UNITS)

clean:
	rm -f $(ALL_UNITS)

../toolembeddedimages.pas: DefaultIcon.png DefaultIconSquare.png
	image-to-pascal --output .. ToolEmbeddedImages DefaultIcon.png \
	@alpha=strip DefaultIconSquare.png

=== src/ui/opengl/gui-images/Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
   FrameThickWhite.png FrameThickYellow.png \
   ProgressBar.png ProgressFill.png \
   TouchCtlInner.png TouchCtlOuter.png TouchCtlFlyInner.png TouchCtlFlyOuter.png \
-  Crosshair1.png Crosshair2.png ErrorBackground.png Loading.png
+  Crosshair1.png Crosshair2.png ErrorBackground.png Loading.png Edit.png
 	image-to-pascal --output .. CastleControlsImages \
 	  Panel.png WindowDarkTransparent.png Slider.png \
 	  Tooltip.png TooltipRounded.png \
@@ -28,4 +28,4 @@
 	  @alpha=strip \
 	  PanelSeparator.png WindowDark.png WindowGray.png \
 	  ScrollbarFrame.png \
-	  SliderPosition.png ErrorBackground.png
+	  SliderPosition.png ErrorBackground.png Edit.png

=== debian/changelog ===
castle-game-engine (6.2+dfsg1-4) unstable; urgency=medium

  * Set FPCDIR on armel/armhf until fpc bug #888697 is fixed

 -- Paul Gevers <elbrus@debian.org>  Fri, 02 Feb 2018 13:19:20 +0100

castle-game-engine (6.2+dfsg1-3) unstable; urgency=medium

  * Fix FTBFS arch:all (without building arch:any at the same time)

 -- Paul Gevers <elbrus@debian.org>  Sun, 28 Jan 2018 19:42:59 +0100

castle-game-engine (6.2+dfsg1-2) unstable; urgency=medium

  * Don't set FPCDIR in d/rules (Closes: #887575)
  * Add patch for reproducible builds (Closes: #868790) Thanks Lamby.
  * Bump dephelper compat level to 11 and set Rules-Requires-Root to no

 -- Paul Gevers <elbrus@debian.org>  Sun, 28 Jan 2018 13:09:54 +0100

castle-game-engine (6.2+dfsg1-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream release
  * Refresh patches: drop most as they were from upstream

 -- Paul Gevers <elbrus@debian.org>  Wed, 12 Jul 2017 21:26:19 +0200

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders:
  Abou Al Montacir <abou.almontacir@sfr.fr>,
  Paul Gevers <elbrus@debian.org>
-Standards-Version: 3.9.8
+Standards-Version: 4.1.3
 Build-Depends:
- debhelper (>= 10~),
+ debhelper (>= 11~),
  dh-exec,
  fonts-dejavu,
  fp-compiler,
@@ -32,9 +32,10 @@
 Build-Depends-Indep:
  inkscape,
  pasdoc (>= 0.14.0),
-Vcs-Git: https://anonscm.debian.org/git/pkg-pascal/castle-game-engine.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-pascal/castle-game-engine.git
+Vcs-Git: https://salsa.debian.org/pascal-team/castle-game-engine.git
+Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine.git
 Homepage: https://castle-engine.sourceforge.io/engine.php
+Rules-Requires-Root: no
 
 Package: fp-units-castle-game-engine
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,7 +1,8 @@
 #!/usr/bin/make -f
 # debian/rules for Castle Game Engine
 
-DEB_PACKAGE_NAME=castle-game-engine
+include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/pkg-info.mk
 export DH_ALWAYS_EXCLUDE := COPYING:LICENSE
 export LANG:=C
 
@@ -24,23 +25,19 @@
 CPU_TARGET?=$(shell ${FPC} -iTP)
 OS_TARGET?=$(shell ${FPC} -iTO)
 FPCTARGET=${CPU_TARGET}-${OS_TARGET}
-# Get version information from changelog file
-DEB_VERSION:=$(shell dpkg-parsechangelog | grep '^Version:' | cut -f 2 -d ' ')
-DEB_UPSTREAM_VERSION:=$(shell echo $(DEB_VERSION) | cut -f 1 -d -)
 # Used in dh-exec enhanced files
-export CGE_VERSION=${DEB_UPSTREAM_VERSION}
-DEB_UPSTREAM_MAIN_VERSION:=$(shell echo ${DEB_UPSTREAM_VERSION} | sed -e 's/^\([0-9\.]*\).*/\1/')
+export CGE_VERSION=${DEB_VERSION_UPSTREAM}
+DEB_UPSTREAM_MAIN_VERSION:=$(shell echo ${DEB_VERSION_UPSTREAM} | sed -e 's/^\([0-9\.]*\).*/\1/')
 DEB_BUILD=$(lastword $(subst -, ,${DEB_VERSION}))
 ifndef PACKAGESUFFIX
 PACKAGESUFFIX=-${DEB_UPSTREAM_MAIN_VERSION}
 endif
-DEB_HOST_MULTIARCH=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 # Get directories
 CURDIR:=$(shell pwd)
 INSTALL_DIR=$(CURDIR)/debian/tmp
-LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_PACKAGE_NAME}/${DEB_UPSTREAM_MAIN_VERSION}
-SRC_DIR=${INSTALL_DIR}/usr/src/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
-UNITS_DIR=${INSTALL_DIR}/usr/lib/${DEB_HOST_MULTIARCH}/fp-units-${FPCVER}/${DEB_PACKAGE_NAME}-${DEB_UPSTREAM_MAIN_VERSION}
+LIB_DIR=${INSTALL_DIR}/usr/lib/${DEB_SOURCE}/${DEB_UPSTREAM_MAIN_VERSION}
+SRC_DIR=${INSTALL_DIR}/usr/src/${DEB_SOURCE}-${DEB_UPSTREAM_MAIN_VERSION}
+UNITS_DIR=${INSTALL_DIR}/usr/lib/${DEB_HOST_MULTIARCH}/fp-units-${FPCVER}/${DEB_SOURCE}-${DEB_UPSTREAM_MAIN_VERSION}
 TMP_DIR=${INSTALL_DIR}/tmp
 # Get utils
 ifndef MKDIR
@@ -54,19 +51,20 @@
 ifndef FPCMAKE
 FPCMAKE=fpcmake
 endif
-# Define FPCDIR if it was not set
-ifndef FPCDIR
-export FPCDIR=/usr/lib/fpc/${FPCVER}
-endif
 ifndef LAZBUILD
 LAZBUILD=lazbuild
 endif
 # Set default compilation options
 BUILDOPTS=
 
-# Until we switch to shorthand dh, we need to set this ourselves for
-# reproducible builds
-export SOURCE_DATE_EPOCH = $(shell date -d "$$(dpkg-parsechangelog -SDate)" +%s)
+# Until bug #888697 against fpc is fixed, we need to specify the FPCDIR on
+# armel and armhf
+ifeq ($(DEB_HOST_ARCH),armel)
+export FPCDIR=/usr/lib/arm-linux-gnueabi/fpc/${FPCVER}
+endif
+ifeq ($(DEB_HOST_ARCH),armhf)
+export FPCDIR=/usr/lib/arm-linux-gnueabihf/fpc/${FPCVER}
+endif
 
 #export DH_VERBOSE=1
 
@@ -120,9 +118,9 @@
 
 	# Upstream source contains auto-generated include files. Let's generate
 	# them again.
-	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg src/x3d/nodes_specification/generate_x3d_nodes_helpers/generate_x3d_nodes_to_pascal.lpr
-	cd src/x3d/nodes_specification/generate_x3d_nodes_helpers ; \
-		PATH=${TMP_DIR} generate_x3d_nodes_to_pascal ../components/*.txt
+	${FPC} -FE${TMP_DIR} -dRELEASE @castle-fpc.cfg src/x3d/nodes_specification/x3d-nodes-to-pascal/x3d-nodes-to-pascal.lpr
+	cd src/x3d/nodes_specification/x3d-nodes-to-pascal ; \
+		PATH=${TMP_DIR} x3d-nodes-to-pascal ../components/*.txt
 
 	# For reproducible builds we need to make sure the timestamp of the just
 	# created files is fixed. Let's use SOURCE_DATE_EPOCH for that. For the
@@ -194,7 +192,7 @@
 	touch install-arch-stamp
 
 build-indep: configure prepare-source install-source build-doc
-install-indep: install-doc install-source
+install-indep: install-source install-doc
 
 ###################
 # Documentation
@@ -227,7 +225,7 @@
 # Annoying thing is we need to do this very early to save lots of overhead. If
 # it can be done on a clean tree, right after prepare-source we don't need
 # cleaning, right.
-install-source: install-source-stamp
+install-source: prepare-source install-source-stamp
 install-source-stamp:
 	@echo "--- Copying the source code"
 	dh_testdir
@@ -263,3 +261,7 @@
 	dh_lintian
 
 ifeq (${DEB_BUILD},0)
+	# We are building upstream debs, install override files for build = 0
+	set -x -e ; cd debian ; for PACKAGE in `sed -n -e 's/Package: \(.*\)/\1/p' control` ; do \
+	  if [ -d $${PACKAGE} ] ; \
+	  then \

## castle-game-engine 6.4%2Bdfsg1

=== examples/library/cpp_winapi_library_tester/Makefile ===
# Compile using g++ for Windows. Works at least with g++ from Cygwin.
#
# Note: if you're compiling a 64-bit application,
# make sure that castleengine.dll is also compiled for 64-bit.
# You may want tc run ../../../src/library/castleengine_compile.sh
# with the -Twin64 -Px86_64 options to force this (since often
# the default fpc compiles for Windows 32-bit).

# Do not link to castleengine.dll this way,
# instead use dynamic loading in ../../../src/library/castlelib_c_loader.cpp
#LINKFLAGS:=-L../../../src/library/ -lcastleengine

# Do not use -lWs2_32, instead use -mwindows following https://cygwin.com/cygwin-ug-net/programming.html
# This works also on 64-bit.
#LINKFLAGS:=-lWs2_32

LINKFLAGS:=-lopengl32

cpp_winapi_library_tester: main.cpp
	g++ $< ../../../src/library/castlelib_c_loader.cpp -mwindows $(LINKFLAGS) -o $@

.PHONY: run
run:
	cp -f ../../../src/library/castleengine.dll .
	./cpp_winapi_library_tester.exe

=== src/x3d/teapot/Makefile ===
teapot.inc: teapot.wrl
	./teapot_3d_to_pascal teapot.wrl > teapot.inc

.PHONY: clean
clean:
	rm -f teapot.inc

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders:
  Abou Al Montacir <abou.almontacir@sfr.fr>,
  Paul Gevers <elbrus@debian.org>
-Standards-Version: 4.1.3
+Standards-Version: 4.5.0
 Build-Depends:
- debhelper (>= 11~),
+ debhelper-compat (= 13),
  dh-exec,
  fonts-dejavu,
  fp-compiler,
@@ -21,6 +21,7 @@
  fp-units-net,
  fp-utils (>= 2.6.2),
  help2man,
+ imagemagick,
  libatk1.0-dev,
  libcairo2-dev,
  libfreetype6-dev,
@@ -28,12 +29,11 @@
  libgtk2.0-dev,
  libgtkglext1-dev,
  libpango1.0-dev,
- xcftools,
 Build-Depends-Indep:
- inkscape,
- pasdoc (>= 0.14.0),
+ inkscape (>= 1.0~),
+ pasdoc (>= 0.15.0~),
 Vcs-Git: https://salsa.debian.org/pascal-team/castle-game-engine.git
-Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine.git
+Vcs-Browser: https://salsa.debian.org/pascal-team/castle-game-engine
 Homepage: https://castle-engine.sourceforge.io/engine.php
 Rules-Requires-Root: no
 
@@ -74,11 +74,14 @@
 Section: doc
 Architecture: all
 Depends:
- ${misc:Depends}
+ ${misc:Depends},
+ fonts-droid-fallback,
+ fonts-dejavu-core,
 Suggests:
  castle-game-engine-src,
  fp-units-castle-game-engine,
  libjs-jquery,
+Multi-Arch: foreign
 Description: Castle Game Engine - Developer's Documentation
  Castle Game Engine is a set of LGPL licenced libraries that are intended to
  ease developing 3D games with FreePascal / Lazarus.
@@ -103,6 +106,7 @@
  lazarus
 Suggests:
  fp-units-castle-game-engine
+Multi-Arch: foreign
 Description: Castle Game Engine - Source code for Lazarus integration
  Castle Game Engine is a set of LGPL licenced libraries that are intended to
  ease developing 3D games with FreePascal / Lazarus.
